function [X]=tridiag_LU(A,Q)

% find size of matrix and initialize 'B'
dim = size(A,1);
B=zeros(dim,dim);

% do the first row and column
for i=1:2
	B(i,1)=A(i,1);
end;
B(1,2)=A(1,2)/B(1,1);


% calculate the rest of the LU matrix
j=2;
n=1;
check=1;
while (i~=dim+1)
	for i=j:dim
		sum=0;
		for n=1:j
			sum = sum + B(i,n)*B(n,j);
		end;
		B(i,j)=A(i,j)-sum;
	end;
	i=j;
	
	for j=j+1:dim
		sum=0;
		for n=1:j
			sum = sum + B(i,n)*B(n,j);
		end;
		B(i,j)= (A(i,j)- sum)/B(i,i);
	end;
	
	j=i+1;
end;

% find U
for i=1:dim
	for j=1:dim
		if (i==j)
		        U(i,j)=1;
	        elseif(i<=j)
			U(i,j)=B(i,j);
		end;
	end;
end;

% find L			
for i=1:dim
	for j=1:dim
		if (i>=j)
			L(i,j)=B(i,j);
		end;
	end;
end;


% Find X
Z=zeros(dim,1);
X=zeros(dim,1);
sum=0;


% find LZ=Q
Z(1,1)=Q(1,1)/L(1,1);
for n=2:1:dim
	Z(n,1)=(Q(n,1)-(L(n,n-1:1)*Z(n-1:1,1)))/L(n,n);
end;


% find UX=Z
X(dim,1)=Z(dim,1)/U(dim,dim);
for n=(dim-1):-1:1
	X(n,1)=(Z(n,1)-U(n,n+1:n)*X(n+1:n,1))/U(dim,dim);
end;
